﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using Microsoft.Win32;
using System;
using System.CodeDom.Compiler;
using System.ComponentModel;
using System.Diagnostics;
using System.IO;
using System.Runtime.CompilerServices;
using System.Threading;
using System.Windows;

namespace hbs_utl
{
    class Program
    {
        static void unpack(string fname_original, string fname_out)
        {
            byte[] databuf = new byte[600];
            int num6 = 0x100;
            byte[] buffer4 = File.ReadAllBytes(fname_original);
            if (buffer4 == null)
            {
                Console.WriteLine("error opening file\n");
            }
            else
            {
                int num10 = buffer4[20] + buffer4[30];
                num10 *= buffer4[21];
                num10 += buffer4[29];
                int num11 = num10;
                num11 *= buffer4[28];
                num10 = buffer4[1] + ((byte)~buffer4[3] * 0x100);
                num11 = (buffer4[num10 + 5] + (buffer4[num10 + 7] << 8)) + (buffer4[num10 + 9] << 16);
                if (num11 > 0x1fc020)
                {
                    Console.WriteLine("File length error");
                }
                else
                {
                    ushort num17 = buffer4[num10 + 12];
                    num17 = (ushort)(num17 | ((ushort)(buffer4[num10 + 13] << 8)));
                    byte[] buffer6 = new byte[10];
                    buffer6[0] = buffer4[num10 + 14];
                    buffer6[1] = buffer4[num10 + 15];
                    buffer6[2] = buffer4[num10 + 16];
                    buffer6[3] = buffer4[num10 + 17];
                    buffer6[4] = buffer4[num10 + 18];
                    buffer6[5] = buffer4[num10 + 19];
                    buffer6[6] = buffer4[num10 + 20];
                    byte[] buffer5 = new byte[num11];
                    int index = 0;
                    int num14 = 0;
                    int num12 = (num10 + 4) + 32;
                    while (index < num11)
                    {
                        byte num16 = buffer4[num12++];
                        byte num15 = buffer4[num12++];
                        if ((index % 4) == 0)
                        {
                            buffer5[index] = (byte)((num16 & 0xF0) >> 4);
                            buffer5[index] = (byte)(buffer5[index] | ((byte)((num15 & 0x0F) << 4)));
                            buffer5[index] = (byte)(buffer5[index] ^ buffer6[num14]);
                        }
                        else if ((index % 4) == 1)
                        {
                            buffer5[index] = (byte)((num16 & 0xF0) >> 4);
                            buffer5[index] = (byte)(buffer5[index] | ((byte)(num15 & 0xF0)));
                            buffer5[index] = (byte)(buffer5[index] ^ buffer6[num14]);
                        }
                        else if ((index % 4) == 2)
                        {
                            buffer5[index] = (byte)(num16 & 0x0F);
                            buffer5[index] = (byte)(buffer5[index] | ((byte)((num15 & 0x0F) << 4)));
                            buffer5[index] = (byte)(buffer5[index] ^ buffer6[num14]);
                        }
                        else if ((index % 4) == 3)
                        {
                            buffer5[index] = (byte)(num16 & 0x0F);
                            buffer5[index] = (byte)(buffer5[index] | ((byte)(num15 & 0xF0)));
                            buffer5[index] = (byte)(buffer5[index] ^ buffer6[num14]);
                        }
                        if (++num14 >= 7)
                        {
                            num14 = 0;
                        }
                        index++;
                    }

                    byte[] buffer2 = new byte[num11];
                    for (index = 0; index < num11; index++)
                    {
                        buffer2[index] = (byte)~buffer5[index];
                    }
                    index = 0;
                    ushort num18 = 0;
                    while (index < num11)
                    {
                        num18 = (ushort)(num18 + buffer2[index++]);
                    }

                    if (num18 != num17)
                    {
                        Console.WriteLine("checksum error");
                    }
                    else
                    {
                        //dump buffers to disk
                        File.WriteAllBytes(fname_out, buffer2);
                    }
                }
            }
        }

        static void pack(string fname_original, string fname_fixed, string fname_out)
        {
            byte[] databuf = new byte[600];
            int num6 = 0x100;
            byte[] buffer2fixed = File.ReadAllBytes(fname_fixed);
            byte[] buffer4 = File.ReadAllBytes(fname_original);
            byte[] buffer4fixed = File.ReadAllBytes(fname_original);
            if (buffer4 == null)
            {
                Console.WriteLine("error opening file\n");
            }
            else
            {
                int num10 = buffer4[20] + buffer4[30];
                num10 *= buffer4[21];
                num10 += buffer4[29];
                int num11 = num10;
                num11 *= buffer4[28];
                num10 = buffer4[1] + ((byte)~buffer4[3] * 0x100);
                num11 = (buffer4[num10 + 5] + (buffer4[num10 + 7] << 8)) + (buffer4[num10 + 9] << 16);
                if (num11 > 0x1fc020)
                {
                    Console.WriteLine("File length error");
                }
                else
                {
                    ushort num17 = buffer4[num10 + 12];
                    num17 = (ushort)(num17 | ((ushort)(buffer4[num10 + 13] << 8)));
                    byte[] buffer6 = new byte[10];
                    buffer6[0] = buffer4[num10 + 14];
                    buffer6[1] = buffer4[num10 + 15];
                    buffer6[2] = buffer4[num10 + 16];
                    buffer6[3] = buffer4[num10 + 17];
                    buffer6[4] = buffer4[num10 + 18];
                    buffer6[5] = buffer4[num10 + 19];
                    buffer6[6] = buffer4[num10 + 20];
                    int index = 0;
                    int num14 = 0;
                    int num12 = (num10 + 4) + 32;
                    while (index < num11)
                    {
                        byte num16 = buffer4[num12++];
                        byte num15 = buffer4[num12++];
                        if ((index % 4) == 0)
                        {
                            buffer4fixed[num12 - 2] = (byte)(num16 & 0xF0);
                            buffer4fixed[num12 - 1] = (byte)(num15 & 0x0F);

                            byte xxx = (byte)(((byte)(~buffer2fixed[index])) ^ buffer6[num14]);
                            byte b1 = (byte)((xxx & 0xF0) >> 4);
                            byte b2 = (byte)((xxx & 0x0F) << 4);
                            b1 = (byte)(b1 | (num15 & 0xF0));
                            b2 = (byte)(b2 | (num16 & 0x0F));
                            buffer4fixed[num12 - 2] = b2;
                            buffer4fixed[num12 - 1] = b1;
                        }
                        else if ((index % 4) == 1)
                        {
                            buffer4fixed[num12 - 2] = (byte)(num16 & 0xF0);
                            buffer4fixed[num12 - 1] = (byte)(num15 & 0xF0);

                            byte xxx = (byte)(((byte)(~buffer2fixed[index])) ^ buffer6[num14]);
                            byte b1 = (byte)((xxx & 0xF0) >> 4);
                            byte b2 = (byte)((xxx & 0x0F) << 4);
                            b1 = (byte)(b1 << 4 | (num15 & 0x0F));
                            b2 = (byte)(b2 | (num16 & 0x0F));
                            buffer4fixed[num12 - 2] = b2;
                            buffer4fixed[num12 - 1] = b1;
                        }
                        else if ((index % 4) == 2)
                        {
                            buffer4fixed[num12 - 2] = (byte)(num16 & 0x0F);
                            buffer4fixed[num12 - 1] = (byte)(num15 & 0x0F);

                            byte xxx = (byte)(((byte)(~buffer2fixed[index])) ^ buffer6[num14]);
                            byte b1 = (byte)((xxx & 0xF0) >> 4);
                            byte b2 = (byte)((xxx & 0x0F) << 4);
                            b1 = (byte)(b1 | (num15 & 0xF0));
                            b2 = (byte)(b2 >> 4 | (num16 & 0xF0));
                            buffer4fixed[num12 - 2] = b2;
                            buffer4fixed[num12 - 1] = b1;
                        }
                        else if ((index % 4) == 3)
                        {
                            buffer4fixed[num12 - 2] = (byte)(num16 & 0x0F);
                            buffer4fixed[num12 - 1] = (byte)(num15 & 0xF0);

                            byte xxx = (byte)(((byte)(~buffer2fixed[index])) ^ buffer6[num14]);
                            byte b1 = (byte)((xxx & 0xF0) >> 4);
                            byte b2 = (byte)((xxx & 0x0F) << 4);
                            b1 = (byte)(b1 << 4 | (num15 & 0x0F));
                            b2 = (byte)(b2 >> 4 | (num16 & 0xF0));
                            buffer4fixed[num12 - 2] = b2;
                            buffer4fixed[num12 - 1] = b1;
                        }
                        if (++num14 >= 7)
                        {
                            num14 = 0;
                        }
                        index++;
                    }

                    //update checksum in modified data
                    ushort new_csum = 0;
                    for (index = 0; index < num11; index++)
                    {
                        new_csum = (ushort)(new_csum + (byte)(buffer2fixed[index]));
                    }
                    buffer4fixed[num10 + 12] = (byte)(new_csum & 0x00FF); ;
                    buffer4fixed[num10 + 13] = (byte)((new_csum & 0xFF00) >> 8);

                    //dump buffers to disk
                    File.WriteAllBytes(fname_out, buffer4fixed);
                }
            }
        }


        static void Main(string[] args)
        {
            unpack(".\\H501s-FC-V1.1.17.hbs", ".\\H501s-FC-V1.1.17_unpacked.hbs");
            if (File.Exists(".\\H501s-FC-V1.1.17_fixed.hbs"))
            {
                pack(".\\H501s-FC-V1.1.17.hbs", ".\\H501s-FC-V1.1.17_fixed.hbs", ".\\H501s-FC-V1.1.17_full_fixed.hbs");
            }
        }
    }
}
